package com.engine.htsc.financialadjustment.pojo;

import com.alibaba.excel.annotation.ExcelProperty;

/**
 * excel template, biz support
 */
public class FinancialAjExcelData {

  @ExcelProperty("是否入会计账")
  private String credit;
  @ExcelProperty("费用承担人")
  private String expensePerson;
  @ExcelProperty("费用承担部门")
  private String expenseDept;
//  @ExcelProperty("预算项目（预算类型-控制项目-明细项目）* ")
  @ExcelProperty(index = 3)
  private String budgetCode;
  @ExcelProperty("金额")
  private String amount;
  @ExcelProperty("是否超预算")
  private String overBudget;
  @ExcelProperty("会计科目")
  private String accountCode;
  @ExcelProperty("借贷方向")
  private String debtSide;
  @ExcelProperty("公司项目")
  private String projectCode;
  @ExcelProperty("项目部门")
  private String projectDept;

  public String getCredit() {
    return credit;
  }

  public void setCredit(String credit) {
    this.credit = credit;
  }

  public String getExpensePerson() {
    return expensePerson;
  }

  public void setExpensePerson(String expensePerson) {
    this.expensePerson = expensePerson;
  }

  public String getExpenseDept() {
    return expenseDept;
  }

  public void setExpenseDept(String expenseDept) {
    this.expenseDept = expenseDept;
  }

  public String getBudgetCode() {
    return budgetCode;
  }

  public void setBudgetCode(String budgetCode) {
    this.budgetCode = budgetCode;
  }

  public String getAmount() {
    return amount;
  }

  public void setAmount(String amount) {
    this.amount = amount;
  }

  public String getOverBudget() {
    return overBudget;
  }

  public void setOverBudget(String overBudget) {
    this.overBudget = overBudget;
  }

  public String getAccountCode() {
    return accountCode;
  }

  public void setAccountCode(String accountCode) {
    this.accountCode = accountCode;
  }

  public String getDebtSide() {
    return debtSide;
  }

  public void setDebtSide(String debtSide) {
    this.debtSide = debtSide;
  }

  public String getProjectCode() {
    return projectCode;
  }

  public void setProjectCode(String projectCode) {
    this.projectCode = projectCode;
  }

  public String getProjectDept() {
    return projectDept;
  }

  public void setProjectDept(String projectDept) {
    this.projectDept = projectDept;
  }

  @Override
  public String toString() {
    return "FinancialAjExcelData{" +
            "credit='" + credit + '\'' +
            ", expensePerson='" + expensePerson + '\'' +
            ", expenseDept='" + expenseDept + '\'' +
            ", budgetCode='" + budgetCode + '\'' +
            ", amount='" + amount + '\'' +
            ", overBudget='" + overBudget + '\'' +
            ", accountCode='" + accountCode + '\'' +
            ", debtSide='" + debtSide + '\'' +
            ", projectCode='" + projectCode + '\'' +
            ", projectDept='" + projectDept + '\'' +
            '}';
  }
}
