package com.engine.htsc.itlxlc.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.itlxlc.cmd.*;
import com.engine.htsc.itlxlc.service.ItlxlcService;
import weaver.hrm.User;
import java.util.Map;

public class ItlxlcServiceImpl extends Service implements ItlxlcService {

    @Override
    public Map<String, Object> createFreeNode(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItlxlcFreeNodeCmd(user,params));
    }

    @Override
    public Map<String, Object> createFreeNodeForOther(Map<String, Object> params) {
        return commandExecutor.execute(new ItlxlcFreeNodeOtherCmd(params));
    }

    @Override
    public Map<String, Object> getYsxgFreeNode(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItlxlcNbshInfoCmd(user,params));
    }

    @Override
    public Map<String, Object> getItlxProject(Map<String, Object> params) {
        return commandExecutor.execute(new ItlxlcProjectCmd(params));
    }

    @Override
    public Map<String, Object> getItlxProjectInfo(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItlxlcProjectInfoCmd(user,params));
    }

    @Override
    public Map<String, Object> getLsdpInfo(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItlxlcLdspInfoCmd(user,params));
    }

    @Override
    public Map<String, Object> getnbshInfo(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItlxlcNbshInfoCmd(user,params));
    }

}
