package com.engine.htsc.lhtybx.web;


import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.lhtybx.service.GetMainJobService;
import com.engine.htsc.lhtybx.service.Impl.GetMainJobServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;
import com.alibaba.fastjson.JSONObject;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

public class GetMainJobAction {

    private GetMainJobService getService(User user) {
        return (GetMainJobServiceImpl) ServiceUtil.getService(GetMainJobServiceImpl.class, user);
    }

    @POST
    @Path("/getMainJob")
    @Produces({MediaType.TEXT_PLAIN})
    public String getMainJob(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try {
            //获取当前用户
            User user = HrmUserVarify.getUser(request, response);

            apidatas.putAll(getService(user).GetMainJob(ParamUtil.request2Map(request)));
            apidatas.put("api_status", true);

        } catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(apidatas);
    }

}
