package com.engine.htsc.meeting.service;

import java.util.List;
import java.util.Map;

public interface MeetingService {

  /**
   * 可选参会人员
   */
  List<Map<String, String>> getParticipants();

  /**
   * 获取form表单
   */
  Map<String, Object> getFormDemo(Map<String, Object> params);


  /**
   * 保存数据
   */
  Map<String, Object> saveFormDemo(Map<String, Object> params);

  /**
   * 会议文件归档
   */
  Map<String, Object> archiving(Map<String, Object> params);


  /**
   * 获取 imageFileIds 的数据详情,前端上传附件用
   */
  Map<String, Object> getImageFileInfoByFieldIds(String imagefileid) throws Exception;

}
