package com.engine.htsc.payment.pojo;

import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.List;

/**
 * 合同接口返回数据
 */
public class ContractInfoVo implements Serializable {

	private static final long serialVersionUID = 7169357361813015204L;
	@JSONField(ordinal = 1)
	private Integer totalRecords;
	@JSONField(ordinal = 2)
	private Integer firstResult;
	@JSONField(ordinal = 3)
	private Integer maxResult;
	@JSONField(ordinal = 4)
	private Boolean isSuccess;
	@JSONField(ordinal = 5)
	private Integer resultState;
	@JSONField(ordinal = 6)
	private String msg;
	@JSONField(ordinal = 7)
	private List<ContractVo> data;

	public Integer getTotalRecords() {
		return totalRecords;
	}

	public void setTotalRecords(Integer totalRecords) {
		this.totalRecords = totalRecords;
	}

	public Integer getFirstResult() {
		return firstResult;
	}

	public void setFirstResult(Integer firstResult) {
		this.firstResult = firstResult;
	}

	public Integer getMaxResult() {
		return maxResult;
	}

	public void setMaxResult(Integer maxResult) {
		this.maxResult = maxResult;
	}

	public Boolean getIsSuccess() {
		return isSuccess;
	}

	public void setIsSuccess(Boolean success) {
		isSuccess = success;
	}

	public Integer getResultState() {
		return resultState;
	}

	public void setResultState(Integer resultState) {
		this.resultState = resultState;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public List<ContractVo> getData() {
		return data;
	}

	public void setData(List<ContractVo> data) {
		this.data = data;
	}

	@Override
	public String toString() {
		return "ContractInfoVo{" +
				"totalRecords=" + totalRecords +
				", firstResult=" + firstResult +
				", maxResult=" + maxResult +
				", isSuccess=" + isSuccess +
				", resultState=" + resultState +
				", msg='" + msg + '\'' +
				", data=" + data +
				'}';
	}
}
