package com.engine.htsc.payment.service;


import com.alibaba.fastjson.JSONObject;
import com.engine.htsc.payment.pojo.SettlePayAutoRequestParam;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public interface SettlePaymentFlowService {

    List<SettlePayAutoRequestParam> getParam(String requestid) throws Exception ;

    String createWorkflowMain(List<SettlePayAutoRequestParam> paramList) throws Exception;

    HashMap<String, String> getSplParam(String requestid);

    String saveSubCompanySpl(HashMap<String, String> reqMap);

    String getSplNgr(String flowType,String orgCode);

    boolean doBudgetMiddleTable(String requestMark, String billStatus);

    boolean insertBudgetMiddleTable(String fName, String billStatus, String yskmTable, String mainTable) throws Exception;

    JSONObject getSettlePaymentSplWeb(HashMap<String, String> reqMap);

    Map<String, String> doAccountByBatchIdZb(String rids) throws Exception;

    Map<String, String> doBudgetByBatchIdZb(String rid, String isDiscard) throws Exception;

    Map<String, String> doAccountByBatchIdFzjg(String rids) throws Exception;

    Map<String, String> doBudgetByBatchIdFzjg(String rid, String isDiscard) throws Exception;

    Map<String, String> doPaymentByBatchIdZb(String rids) throws Exception;

    Map<String, String> doPaymentByBatchIdFzjg(String rids) throws Exception;

    String updateManualPaymentStatusZb(String rids);

    String updateManualPaymentStatusFzjg(String rids);

}
