package com.engine.htsc.portal.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.portal.cmd.ParticipateListCmd;
import com.engine.htsc.portal.cmd.PortalTransactionCmd;
import com.engine.htsc.portal.service.PortalTransactionService;
import java.util.Map;

public class PortalTransactionServiceImpl extends Service implements PortalTransactionService {

    /**
     * 协同中心首页
     * @param params
     * @return
     */
    @Override
    public Map<String, Object> getStatisticalCount(Map<String, Object> params) {
        return commandExecutor.execute(new PortalTransactionCmd(params, user));
    }

    @Override
    public Map<String, Object> getParticipateList(Map<String, Object> params) {
        return commandExecutor.execute(new ParticipateListCmd(params, user));
    }
}
