package com.engine.htsc.subcompany.model;

//审批链建模数据库实体（和数据库表对应）
public class UfZgsspl {
    private Integer id; //数据ID
    private String bm;//部门code 具体部门的唯一标识，示例：ZZ001014
    private String ptbm;//排他部门 逗号分割（黑名单保留字段）
    private String cxsprjs;//角色 定义报销人员或拟稿人的角色编码，枚举值例如PT，PT_LV2，FZR，FZR_LV2，代码侧做解码操作
    private String cxspr;//拟稿人/报销人
    private String sslc;//所属流程
    private String jg;//机构code 泛微中华泰集团、华泰联合、华泰资管、华泰香港、紫金、创新等组织机构唯一标识，示例：ZZ001或ZZ001051（和部门code相区别的是，结构为六大子公司根节点编码，不用id的原因是生产和测试id不同，减少上生产工作量）
    private String tj;//条件1 定义的审批链条件，代码侧做解码操作，示例：0<amount<=5000
    //以下是审批链审批节点定义
    private String ejbmfzr;//二级部门负责人 0或空或自定义编码 数据库用来判断是否跳过
    private String zjsjsh;//直接上级审核（香港特有）
    private String fyqr;//费用确认
    private String nbsh;//内部审核
    private String yjbmfzr;//一级部门负责人
    private String fycdbmfzr;//费用承担部门负责人（紫金虚拟基金特有）
    private String xmfzr;//项目负责人（联合投行项目特有）
    private String thqyfzr;//投行区域负责人（联合投行等二级部特有）
    private String xmssbmfzr;//项目所属部门负责人
    private String fyg;//费用岗审核
    private String kj;//财务中心会计
    private String cwjl;//财务中心经理
    private String hqbmfzr;//会签部门负责人
    private String gsywfzr;//固收业务负责人（资管特有）
    private String fgld;//分管领导
    private String cwfgld;//财务分管领导（联合付款特有）
    private String zgszjl;//子公司总经理
    private String zc;//总裁（联合特有）
    private String zgsdsz;//子公司董事长
    private String kjcl;//会计处理（联合特有）
    private String sxyyg;//首席运营官
    private String sxzxg;//首席执行官
    private String cwzxcn;//财务中心出纳
    private String hqbmflb;//会签部门法律部
    private String hqbmfxglb;//会签部门风险管理部
    private String zbzjglg;//总部资金管理岗
    private String zbzjyybfzr;//总部资金运营部负责人
    private String jtld;//集团领导
    private String sxcwg;//首席财务官
    private String sxfxg;//首席风险官
    private String ysgly;//预算管理员
    private String cwglbfzr;//财务管理部负责人
    private String ghzx;//工会主席
    private String zjzjl;//紫金总经理

    public UfZgsspl() {
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getBm() {
        return bm;
    }

    public void setBm(String bm) {
        this.bm = bm;
    }

    public String getPtbm() {
        return ptbm;
    }

    public void setPtbm(String ptbm) {
        this.ptbm = ptbm;
    }

    public String getCxsprjs() {
        return cxsprjs;
    }

    public void setCxsprjs(String cxsprjs) {
        this.cxsprjs = cxsprjs;
    }

    public String getCxspr() {
        return cxspr;
    }

    public void setCxspr(String cxspr) {
        this.cxspr = cxspr;
    }

    public String getSslc() {
        return sslc;
    }

    public void setSslc(String sslc) {
        this.sslc = sslc;
    }

    public String getJg() {
        return jg;
    }

    public void setJg(String jg) {
        this.jg = jg;
    }

    public String getTj() {
        return tj;
    }

    public void setTj(String tj) {
        this.tj = tj;
    }

    public String getEjbmfzr() {
        return ejbmfzr;
    }

    public void setEjbmfzr(String ejbmfzr) {
        this.ejbmfzr = ejbmfzr;
    }

    public String getZjsjsh() {
        return zjsjsh;
    }

    public void setZjsjsh(String zjsjsh) {
        this.zjsjsh = zjsjsh;
    }

    public String getFyqr() {
        return fyqr;
    }

    public void setFyqr(String fyqr) {
        this.fyqr = fyqr;
    }

    public String getNbsh() {
        return nbsh;
    }

    public void setNbsh(String nbsh) {
        this.nbsh = nbsh;
    }

    public String getYjbmfzr() {
        return yjbmfzr;
    }

    public void setYjbmfzr(String yjbmfzr) {
        this.yjbmfzr = yjbmfzr;
    }

    public String getFycdbmfzr() {
        return fycdbmfzr;
    }

    public void setFycdbmfzr(String fycdbmfzr) {
        this.fycdbmfzr = fycdbmfzr;
    }

    public String getXmfzr() {
        return xmfzr;
    }

    public void setXmfzr(String xmfzr) {
        this.xmfzr = xmfzr;
    }

    public String getThqyfzr() {
        return thqyfzr;
    }

    public void setThqyfzr(String thqyfzr) {
        this.thqyfzr = thqyfzr;
    }

    public String getXmssbmfzr() {
        return xmssbmfzr;
    }

    public void setXmssbmfzr(String xmssbmfzr) {
        this.xmssbmfzr = xmssbmfzr;
    }

    public String getKj() {
        return kj;
    }

    public void setKj(String kj) {
        this.kj = kj;
    }

    public String getCwjl() {
        return cwjl;
    }

    public void setCwjl(String cwjl) {
        this.cwjl = cwjl;
    }

    public String getHqbmfzr() {
        return hqbmfzr;
    }

    public void setHqbmfzr(String hqbmfzr) {
        this.hqbmfzr = hqbmfzr;
    }

    public String getGsywfzr() {
        return gsywfzr;
    }

    public void setGsywfzr(String gsywfzr) {
        this.gsywfzr = gsywfzr;
    }

    public String getFgld() {
        return fgld;
    }

    public void setFgld(String fgld) {
        this.fgld = fgld;
    }

    public String getCwfgld() {
        return cwfgld;
    }

    public void setCwfgld(String cwfgld) {
        this.cwfgld = cwfgld;
    }

    public String getZgszjl() {
        return zgszjl;
    }

    public void setZgszjl(String zgszjl) {
        this.zgszjl = zgszjl;
    }

    public String getZc() {
        return zc;
    }

    public void setZc(String zc) {
        this.zc = zc;
    }

    public String getZgsdsz() {
        return zgsdsz;
    }

    public void setZgsdsz(String zgsdsz) {
        this.zgsdsz = zgsdsz;
    }

    public String getKjcl() {
        return kjcl;
    }

    public void setKjcl(String kjcl) {
        this.kjcl = kjcl;
    }

    public String getFyg() {
        return fyg;
    }

    public void setFyg(String fyg) {
        this.fyg = fyg;
    }

    public String getSxyyg() {
        return sxyyg;
    }

    public void setSxyyg(String sxyyg) {
        this.sxyyg = sxyyg;
    }

    public String getSxzxg() {
        return sxzxg;
    }

    public void setSxzxg(String sxzxg) {
        this.sxzxg = sxzxg;
    }

    public String getCwzxcn() {
        return cwzxcn;
    }

    public void setCwzxcn(String cwzxcn) {
        this.cwzxcn = cwzxcn;
    }

    public String getHqbmflb() {
        return hqbmflb;
    }

    public void setHqbmflb(String hqbmflb) {
        this.hqbmflb = hqbmflb;
    }

    public String getHqbmfxglb() {
        return hqbmfxglb;
    }

    public void setHqbmfxglb(String hqbmfxglb) {
        this.hqbmfxglb = hqbmfxglb;
    }

    public String getZbzjglg() {
        return zbzjglg;
    }

    public void setZbzjglg(String zbzjglg) {
        this.zbzjglg = zbzjglg;
    }

    public String getZbzjyybfzr() {
        return zbzjyybfzr;
    }

    public void setZbzjyybfzr(String zbzjyybfzr) {
        this.zbzjyybfzr = zbzjyybfzr;
    }

    public String getJtld() {
        return jtld;
    }

    public void setJtld(String jtld) {
        this.jtld = jtld;
    }

    public String getSxcwg() {
        return sxcwg;
    }

    public void setSxcwg(String sxcwg) {
        this.sxcwg = sxcwg;
    }

    public String getSxfxg() {
        return sxfxg;
    }

    public void setSxfxg(String sxfxg) {
        this.sxfxg = sxfxg;
    }

    public String getYsgly() {
        return ysgly;
    }

    public void setYsgly(String ysgly) {
        this.ysgly = ysgly;
    }

    public String getCwglbfzr() {
        return cwglbfzr;
    }

    public void setCwglbfzr(String cwglbfzr) {
        this.cwglbfzr = cwglbfzr;
    }

    public String getGhzx() {
        return ghzx;
    }

    public void setGhzx(String ghzx) {
        this.ghzx = ghzx;
    }

    public String getZjzjl() {
        return zjzjl;
    }

    public void setZjzjl(String zjzjl) {
        this.zjzjl = zjzjl;
    }
}
