package com.engine.htsc.trip.cmd;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import java.util.HashMap;
import java.util.Map;
import weaver.hrm.User;
import weaver.interfaces.htsc.cus.HTUtil;

public class ResetImageAndBillCmd extends AbstractCommonCommand<Map<String, Object>> {
  
  public ResetImageAndBillCmd(User user, Map<String, Object> params) {
    this.user = user;
    this.params = params;
  }
  
  @Override
  public BizLogContext getLogContext() {
    return null;
  }
  
  @Override
  public Map<String, Object> execute(CommandContext commandContext) {
    Map<String, Object> apidatas = new HashMap<>();
    try {
      HTUtil ht = new HTUtil();
      String datas = ht.resetImageAndBill(params);
      apidatas.put("datas", datas);
    } catch (Exception e) {
      e.printStackTrace();
      return apidatas;
    }
    return apidatas;
  }
}
