package com.engine.htsc.trip.service;

import java.util.List;

/**
 * Created by qlk
 */
public interface BtService {

    /**
     * 获取差旅标准
     * @param travelers 出差人
     * @param destinations 出差地
     * @return List<String>
     */
    List<String> getTravelStandard(String travelers, String destinations);

    Boolean checkNames(String names);

    Boolean checkDeptAndName(String dept, String name);

    String getDirectors(String dept, String expDept);

}
