package com.engine.htsc.branch.approvalChain.tools;

import com.weaver.general.Util;
import weaver.conn.RecordSet;

import java.util.Arrays;

/**
 * 费用分摊审批链工具类
 */
public class FzjgModelTools {

    public static String getFyftJobCrade(String userId) {
        String sql = "select a.deptTypeCode,a.deptdepth,a.deptdirectors,h.SECLEVEL " +
                "from hrmdepartmentdefined a,hrmresource h where a.deptid = h.departmentid " +
                " and h.id = " + userId + "";
        RecordSet rs = new RecordSet();
        rs.execute(sql);
        Integer deptdepth = null;
        Integer secLevel = null;
        String deptTypeCode = null;
        String result = "";
        if (rs.next()) {
            deptdepth = Util.getIntValue(Util.null2String(rs.getString("deptdepth")));
            deptTypeCode = Util.null2String(rs.getString("deptTypeCode"));
            secLevel = Util.getIntValue(Util.null2String(rs.getString("SECLEVEL")));
            if (secLevel>=0&&secLevel<50) {
                if ("JGLX09".equals(deptTypeCode)){
                    result = "ST_1";//分支机构-分公司二级部（业务部） 普通员工
                }
                if("JGLX03".equals(deptTypeCode)){
                    result = "ST_3";//分支机构-分公司 普通员工
                }
                if("JGLX04".equals(deptTypeCode)){
                    result = "ST_5";//分支机构-分公司辖属营业部 普通员工
                }
                if("JGLX02".equals(deptTypeCode)){
                    result = "ST_7";//财富管理部-私行中心 普通员工
                }
            } else if (50 == secLevel) {
                if ("JGLX09".equals(deptTypeCode)){
                    result = "ST_2";//分支机构-分公司二级部（业务部） 负责人
                }
                if("JGLX03".equals(deptTypeCode)){
                    result = "ST_4";//分支机构-分公司 负责人
                }
                if("JGLX04".equals(deptTypeCode)){
                    result = "ST_6";//分支机构-分公司辖属营业部 负责人
                }
                if("JGLX02".equals(deptTypeCode)){
                    result = "ST_8";//财富管理部-私行中心 负责人
                }
            }
        }
        return result;
    }

    public static String getFyftClbxJobCrade(String userId,String departmentid) {
        String sql = "select a.deptTypeCode,a.deptdepth,a.deptdirectors,h.SECLEVEL,h.departmentid,h.id from hrmdepartmentdefined a,hrmresource h " +
                "where a.deptid= '"+departmentid+"' and h.id = '"+userId+"'";
        RecordSet rs = new RecordSet();
        rs.execute(sql);
        Integer deptdepth = null;
        Integer secLevel = null;
        String deptTypeCode = null;
        String result = "";
        if (rs.next()) {
            deptdepth = Util.getIntValue(Util.null2String(rs.getString("deptdepth")));
            deptTypeCode = Util.null2String(rs.getString("deptTypeCode"));
            secLevel = Util.getIntValue(Util.null2String(rs.getString("SECLEVEL")));
            if (secLevel>=0&&secLevel<50) {
                if ("JGLX09".equals(deptTypeCode)){
                    result = "ST_1";//分支机构-分公司二级部（业务部） 普通员工
                }
                if("JGLX03".equals(deptTypeCode)){
                    result = "ST_3";//分支机构-分公司 普通员工
                }
                if("JGLX04".equals(deptTypeCode)){
                    result = "ST_5";//分支机构-分公司辖属营业部 普通员工
                }
                if("JGLX02".equals(deptTypeCode)){
                    result = "ST_7";//财富管理部-私行中心 普通员工
                }
            } else if (50 == secLevel) {
                if ("JGLX09".equals(deptTypeCode)){
                    result = "ST_2";//分支机构-分公司二级部（业务部） 负责人
                }
                if("JGLX03".equals(deptTypeCode)){
                    result = "ST_4";//分支机构-分公司 负责人
                }
                if("JGLX04".equals(deptTypeCode)){
                    result = "ST_6";//分支机构-分公司辖属营业部 负责人
                }
                if("JGLX02".equals(deptTypeCode)){
                    result = "ST_8";//财富管理部-私行中心 负责人
                }
            }
        }
        return result;
    }

}
