package com.engine.htsc.branchpayment.enums;

public enum OperateMsg {

  BUDGET_FAIL("预算失败"),
  BUDGET_SUCCESS("预算成功"),
  BUDGET_CANCEL_SUCCESS("废弃成功"),

  ACCOUNTING_FAIL("核算失败"),
  ACCOUNTING_SUCCESS("核算成功"),

  PAY_SUCCESS("付款成功"),
  PAY_FAIL("付款失败");

  private final String msg;

  public String getMsg() {
    return msg;
  }

  public String getMsg(String additionMsg) {
    return String.join(",", msg, additionMsg);
  }

  OperateMsg(String msg) {
    this.msg = msg;
  }
}
