package com.engine.htsc.common.service;

public interface CoWorkflowService {

  /**
   * 生成流程编号
   *
   * @param workflowId 流程wfId
   * @return string
   */
  String createRequestMark(String workflowId) throws Exception;

  /**
   * 流程编号生成方式,type区分流程,序列获取
   *
   * @param wfid 流程workflowId
   * @param type 类型 0:总部;1:分支机构;2:子公司
   * @return 流程编号, 序列中生成
   */
  String createRequestMarkByType(String wfid, String type) throws Exception;
}
