package com.engine.htsc.fundbusinesspay.service;


import java.util.Map;

public interface FundBusinessService {


	/**
	 * 预算科目对应会计科目信息
	 * 资金业务付款：会计节点
	 * 付款明细预算科目带出会计科目会计科目
	 * @param budgetCode 付款明细预算科目code
	 * @return ec浏览按钮
	 */
	String getKjBrowserValue(String budgetCode) throws Exception;

	/**
	 * @param startDate 开始日期
	 *
	 * @return 可选时间段
	 */
	Map<String, String> getPaymentDateRange(String startDate) throws Exception;


}
