package com.engine.htsc.jgxt.service;

import com.alibaba.fastjson.JSONObject;
import weaver.hrm.User;

import java.util.Map;

public interface JgxtVfServer {

    public JSONObject deptvf(Map<String,Object> map);

    public JSONObject deptvfValue(Map<String,Object> map);

    public JSONObject getfreenode(Map<String,Object> map);

    public JSONObject getuser(Map<String,Object> map);

    public String createtreenode(Map<String,Object> map);


    public String getleaderuserlist(Map<String,Object> map);

    public String feedbacktodetail(Map<String,Object> map, User user);

    public JSONObject getdeptnametoid(Map<String,Object> map);

    /**
     * @title getBusinessName
     * @remark 分公司获取营业部的名称
     * @author xf
     * @updateTime 2022/1/18
     * @return: java.lang.String
     */
    public String getBusinessName(Map<String,Object> map);

    /**
     * @title updatelabeltype
     * @remark 修改标签类型
     * @author xf
     * @updateTime 2022/1/20
     * @return: java.lang.String
     */
    public String updatelabeltype(Map<String,Object> map);
}
