package com.engine.htsc.jjhtyfk.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.jjhtyfk.cmd.GetContractInfoCmd;
import com.engine.htsc.jjhtyfk.service.GetContractInfoService;

import java.util.Map;

/**
 * @Author Weaver.SongYuchen
 * @Date 2022-03-31
 * @Description 付款流程联动用印流程合同信息
 */
public class GetContractInfoServiceImpl extends Service implements GetContractInfoService {
    /**
     * 获取用印流程合同信息
     *
     * @param params
     * @return
     */
    @Override
    public Map<String, Object> getContractInfo(Map<String, Object> params) {
        return commandExecutor.execute(new GetContractInfoCmd(user, params));
    }
}
