package com.engine.htsc.payment.enums;

/**
 * 核算 lb 参数{@link weaver.interfaces.htsc.cus.HTUtil}
 */
public enum HsType {

	LHCLBX("", "lhcl"), //联合差旅报销费用核算
	LHPTBX("","lhpt"), //联合普通报销费用核算
	LHFK("","lhfk"), //联合付款费用核算
	ZBCLBX("10","htcl"), //总部差旅报销费用核算
	ZBPTBX("9","htpt"), //总部普通报销费用核算
	CGSCFK("4", "cgsc"), //采购商城付款费用核算
	ZBFK("0,1,2","htfk"); //总部付款费用核算

	//id 对应 建模 uf_zbfk 中付款类型字段
	private final String id;
	private final String type;

	HsType(String id, String type) {
		this.id = id;
		this.type = type;
	}

	public String getType() {
		return type;
	}

	public String getId() {
		return id;
	}
}
