package com.engine.htsc.payment.pojo;


import com.alibaba.fastjson.annotation.JSONField;

import java.io.Serializable;
import java.util.List;

/**
 * 付款流程预算接口入参 {@link weaver.interfaces.htsc.cus.HTUtil}
 */
public class BudgetDTO implements Serializable {
	private static final long serialVersionUID = -624377204568331845L;

	@JSONField(name = "billnum")
	private String billNum;
	@JSONField(name = "bizdate")
	private String bizDate;
	@JSONField(name = "billstatus")
	private String billStatus;
	@JSONField(name = "billname")
	private String billName;
	@JSONField(name = "billtitle")
	private String billTitle;
	private String pesonName;

	@JSONField(name = "sfyfp")
	private String sfyfp;
	private List<BudgetList> list;

	public String getBillNum() {
		return billNum;
	}

	public void setBillNum(String billNum) {
		this.billNum = billNum;
	}

	public String getBizDate() {
		return bizDate;
	}

	public void setBizDate(String bizDate) {
		this.bizDate = bizDate;
	}

	public String getBillStatus() {
		return billStatus;
	}

	public void setBillStatus(String billStatus) {
		this.billStatus = billStatus;
	}

	public String getBillName() {
		return billName;
	}

	public void setBillName(String billName) {
		this.billName = billName;
	}

	public String getBillTitle() {
		return billTitle;
	}

	public void setBillTitle(String billTitle) {
		this.billTitle = billTitle;
	}

	public String getPesonName() {
		return pesonName;
	}

	public void setPesonName(String pesonName) {
		this.pesonName = pesonName;
	}

	public List<BudgetList> getList() {
		return list;
	}

	public void setList(List<BudgetList> list) {
		this.list = list;
	}

	public String getSFYFP() {
		return sfyfp;
	}

	public void setSFYFP(String sfyfp) {
		this.sfyfp = sfyfp;
	}
}