package com.engine.htsc.payment.pojo;

import java.io.Serializable;

/**
 * 请求信息封装
 */
public class ContractRequestJson implements Serializable {

	private static final long serialVersionUID = 4626492147447527232L;

	private String ctrctCode;
	private String ctrctName;
	private Integer curPage;
	private Integer firstResult;
	private Integer maxResult;
	private String moduleCode;
	private String oaCode;
	private String oaPayUrl;
	private Boolean pagination;
	private String paymentDate;
	private String paymentMoney;
	private String processCode;
	private String sysCode;
	private String userId;

	public String getCtrctCode() {
		return ctrctCode;
	}

	public void setCtrctCode(String ctrctCode) {
		this.ctrctCode = ctrctCode;
	}

	public String getCtrctName() {
		return ctrctName;
	}

	public void setCtrctName(String ctrctName) {
		this.ctrctName = ctrctName;
	}

	public Integer getCurPage() {
		return curPage;
	}

	public void setCurPage(Integer curPage) {
		this.curPage = curPage;
	}

	public Integer getFirstResult() {
		return firstResult;
	}

	public void setFirstResult(Integer firstResult) {
		this.firstResult = firstResult;
	}

	public Integer getMaxResult() {
		return maxResult;
	}

	public void setMaxResult(Integer maxResult) {
		this.maxResult = maxResult;
	}

	public String getModuleCode() {
		return moduleCode;
	}

	public void setModuleCode(String moduleCode) {
		this.moduleCode = moduleCode;
	}

	public String getOaCode() {
		return oaCode;
	}

	public void setOaCode(String oaCode) {
		this.oaCode = oaCode;
	}

	public String getOaPayUrl() {
		return oaPayUrl;
	}

	public void setOaPayUrl(String oaPayUrl) {
		this.oaPayUrl = oaPayUrl;
	}

	public Boolean getPagination() {
		return pagination;
	}

	public void setPagination(Boolean pagination) {
		this.pagination = pagination;
	}

	public String getPaymentDate() {
		return paymentDate;
	}

	public void setPaymentDate(String paymentDate) {
		this.paymentDate = paymentDate;
	}

	public String getPaymentMoney() {
		return paymentMoney;
	}

	public void setPaymentMoney(String paymentMoney) {
		this.paymentMoney = paymentMoney;
	}

	public String getProcessCode() {
		return processCode;
	}

	public void setProcessCode(String processCode) {
		this.processCode = processCode;
	}

	public String getSysCode() {
		return sysCode;
	}

	public void setSysCode(String sysCode) {
		this.sysCode = sysCode;
	}

	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	@Override
	public String toString() {
		return "ContractRequestJson{" +
				"ctrctCode='" + ctrctCode + '\'' +
				", ctrctName='" + ctrctName + '\'' +
				", curPage=" + curPage +
				", firstResult=" + firstResult +
				", maxResult=" + maxResult +
				", moduleCode='" + moduleCode + '\'' +
				", oaCode='" + oaCode + '\'' +
				", oaPayUrl='" + oaPayUrl + '\'' +
				", pagination=" + pagination +
				", paymentDate='" + paymentDate + '\'' +
				", paymentMoney='" + paymentMoney + '\'' +
				", processCode='" + processCode + '\'' +
				", sysCode='" + sysCode + '\'' +
				", userId='" + userId + '\'' +
				'}';
	}
}
