package com.engine.htsc.receipt.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.receipt.service.ReceiptDirectorService;
import com.engine.htsc.receipt.service.ReceiptWaitService;
import weaver.general.BaseBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * create by PTY
 */
public class ReceiptWaitAction {

    ReceiptWaitService getService(){
        return ServiceUtil.getService(ReceiptWaitService.class);
    }

    @POST
    @Path("/updateWait")
    @Produces({MediaType.TEXT_PLAIN})
    public String updateWait(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----receipt-----");
        try{
            String userid = request.getParameter("userid");
            String requestid = request.getParameter("requestid");
            String type = request.getParameter("type");

            ReceiptWaitService receiptWaitService = getService();
            receiptWaitService.updateWait(requestid,userid,type);
            apidatas.put("api_status",true);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

    @POST
    @Path("/getWaitStatus")
    @Produces({MediaType.TEXT_PLAIN})
    public String getWaitStatus(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----receipt-----");
        try{
            String userid = request.getParameter("userid");
            String requestid = request.getParameter("requestid");

            ReceiptWaitService receiptWaitService = getService();
            apidatas = receiptWaitService.getWaitStatus(requestid,userid);
            apidatas.put("api_status",true);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }
}
