package com.engine.htsc.response.enums;

import com.engine.htsc.response.constant.StatusConst;

public enum StatusEnum {

    /**
     * 正常的数据
     */
    OK(StatusConst.OK, "启用"),

    /**
     * 数据已被删除
     */
    DELETE(StatusConst.DELETE, "删除");

    private Byte code;

    private String message;

    StatusEnum(Byte code, String message) {
        this.code = code;
        this.message = message;
    }

    public Byte getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }
}
