package com.engine.htsc.seal.entity;


import java.io.Serializable;
import java.util.List;

public class ManualSignEntity implements Serializable {

    public String appId;
    public String secret;
    public String flowName;//签署事件名称
    public String flowNum;//签署事件编码
    public FlowOwner flowOwner;//签署事件发起方
    public List<DocSign> docSigns;//签署合同列表
    public String signUserId;//签署人ID
    public String signUserName;//签署人名称
    public String autoSignState;//内部签署方是否自动签署

    public String getAppId() {
        return appId;
    }

    public void setAppId(String appId) {
        this.appId = appId;
    }

    public String getSecret() {
        return secret;
    }

    public void setSecret(String secret) {
        this.secret = secret;
    }

    public String getFlowName() {
        return flowName;
    }

    public void setFlowName(String flowName) {
        this.flowName = flowName;
    }

    public String getFlowNum() {
        return flowNum;
    }

    public void setFlowNum(String flowNum) {
        this.flowNum = flowNum;
    }

    public FlowOwner getFlowOwner() {
        return flowOwner;
    }

    public void setFlowOwner(FlowOwner flowOwner) {
        this.flowOwner = flowOwner;
    }

    public List<DocSign> getDocSigns() {
        return docSigns;
    }

    public void setDocSigns(List<DocSign> docSigns) {
        this.docSigns = docSigns;
    }

    public String getSignUserId() {
        return signUserId;
    }

    public void setSignUserId(String signUserId) {
        this.signUserId = signUserId;
    }

    public String getSignUserName() {
        return signUserName;
    }

    public void setSignUserName(String signUserName) {
        this.signUserName = signUserName;
    }

    public String getAutoSignState() {
        return autoSignState;
    }

    public void setAutoSignState(String autoSignState) {
        this.autoSignState = autoSignState;
    }
}
