package com.engine.htsc.subcompany.model;

public class ReportSequenceVO {
    private ZgsUser zgsUser;
    private ZgsDept zgsDept;
    private UfZgsspl ufZgsspl;
    //BXBMVO fycdbmVO; 付款则是费用承担部门
    private String reportSequenceId;//匹配到的数据库审批链id
    private String tj1;//条件1 定义的审批链条件，代码侧做解码操作
    private String tj2;//条件2
    private String tj3;//条件3 未来其他条件横向拓展
    private String jg;//机构id 泛微中华泰集团、华泰联合、华泰资管、华泰香港、紫金、创新等组织机构唯一标识
    private String bm;//部门id 具体部门的唯一标识
    private String js;//角色 定义报销人员或拟稿人的角色编码，枚举值例如PT，PT_LV2，FZR，FZR_LV2，代码侧做解码操作
    private String ex_bm;//排他部门
    private String ex_js;//排他角色
    private String nbsh;//内部审核
    private String ngr;//拟稿人
    private String cn;//出纳，暂定为空
    //以下是审批链审批节点定义
    //具体的审批链 节点名 值定义和代码侧做解码操作
    //以下是审批链审批节点定义
    private String fyqr;//费用确认
    private String xmfzr;//项目负责人（联合投行项目特有）
    private String zjsjsh;//直接上级审核（香港特有）
    private String ejbmfzr;//二级部门负责人 0或空或自定义编码 数据库用来判断是否跳过
    private String thqyfzr;//投行区域负责人（联合投行等二级部特有）
    private String yjbmfzr;//一级部门负责人
    private String xmssbmfzr;//项目所属部门负责人
    private String fyg;//费用岗审核
    private String kj;//财务中心会计
    private String cwjl;//财务中心经理
    private String hqbmfzr;//会签部门负责人
    private String gsywfzr;//固收业务负责人（资管特有）
    private String fycdbmfzr;//费用承担部门负责人（紫金虚拟基金特有）
    private String fgld;//分管领导
    private String cwfgld;//财务分管领导（联合付款特有）
    private String zgszjl;//子公司总经理
    private String zc;//总裁（联合特有）
    private String zgsdsz;//子公司董事长
    private String kjcl;//会计处理（联合特有）
    private String sxyyg;//首席运营官
    private String sxzxg;//首席执行官
    private String cwzxcn;//财务中心出纳
    private String hqbmflb;//会签部门法律部
    private String hqbmfxglb;//会签部门风险管理部
    private String zbzjglg;//总部资金管理岗
    private String zbzjyybfzr;//总部资金运营部负责人
    private String jtld;//集团领导
    private String sxcwg;//首席财务官
    private String sxfxg;//首席风险官
    private String ysgly;//预算管理员
    private String cwglbfzr;//财务管理部负责人
    private String ghzx;//工会主席
    private String zjzjl;//紫金总经理


    public ZgsUser getZgsUser() {
        return zgsUser;
    }

    public void setZgsUser(ZgsUser zgsUser) {
        this.zgsUser = zgsUser;
    }

    public ZgsDept getZgsDept() {
        return zgsDept;
    }

    public void setZgsDept(ZgsDept zgsDept) {
        this.zgsDept = zgsDept;
    }

    public UfZgsspl getUfZgsspl() {
        return ufZgsspl;
    }

    public void setUfZgsspl(UfZgsspl ufZgsspl) {
        this.ufZgsspl = ufZgsspl;
    }

    public String getReportSequenceId() {
        return reportSequenceId;
    }

    public void setReportSequenceId(String reportSequenceId) {
        this.reportSequenceId = reportSequenceId;
    }

    public String getTj1() {
        return tj1;
    }

    public void setTj1(String tj1) {
        this.tj1 = tj1;
    }

    public String getTj2() {
        return tj2;
    }

    public void setTj2(String tj2) {
        this.tj2 = tj2;
    }

    public String getTj3() {
        return tj3;
    }

    public void setTj3(String tj3) {
        this.tj3 = tj3;
    }

    public String getJg() {
        return jg;
    }

    public void setJg(String jg) {
        this.jg = jg;
    }

    public String getBm() {
        return bm;
    }

    public void setBm(String bm) {
        this.bm = bm;
    }

    public String getJs() {
        return js;
    }

    public void setJs(String js) {
        this.js = js;
    }

    public String getEx_bm() {
        return ex_bm;
    }

    public void setEx_bm(String ex_bm) {
        this.ex_bm = ex_bm;
    }

    public String getEx_js() {
        return ex_js;
    }

    public void setEx_js(String ex_js) {
        this.ex_js = ex_js;
    }

    public String getNbsh() {
        return nbsh;
    }

    public void setNbsh(String nbsh) {
        this.nbsh = nbsh;
    }

    public String getCn() {
        return cn;
    }

    public void setCn(String cn) {
        this.cn = cn;
    }

    public String getFyqr() {
        return fyqr;
    }

    public void setFyqr(String fyqr) {
        this.fyqr = fyqr;
    }

    public String getXmfzr() {
        return xmfzr;
    }

    public void setXmfzr(String xmfzr) {
        this.xmfzr = xmfzr;
    }

    public String getZjsjsh() {
        return zjsjsh;
    }

    public void setZjsjsh(String zjsjsh) {
        this.zjsjsh = zjsjsh;
    }

    public String getEjbmfzr() {
        return ejbmfzr;
    }

    public void setEjbmfzr(String ejbmfzr) {
        this.ejbmfzr = ejbmfzr;
    }

    public String getThqyfzr() {
        return thqyfzr;
    }

    public void setThqyfzr(String thqyfzr) {
        this.thqyfzr = thqyfzr;
    }

    public String getYjbmfzr() {
        return yjbmfzr;
    }

    public void setYjbmfzr(String yjbmfzr) {
        this.yjbmfzr = yjbmfzr;
    }

    public String getXmssbmfzr() {
        return xmssbmfzr;
    }

    public void setXmssbmfzr(String xmssbmfzr) {
        this.xmssbmfzr = xmssbmfzr;
    }

    public String getKj() {
        return kj;
    }

    public void setKj(String kj) {
        this.kj = kj;
    }

    public String getCwjl() {
        return cwjl;
    }

    public void setCwjl(String cwjl) {
        this.cwjl = cwjl;
    }

    public String getHqbmfzr() {
        return hqbmfzr;
    }

    public void setHqbmfzr(String hqbmfzr) {
        this.hqbmfzr = hqbmfzr;
    }

    public String getGsywfzr() {
        return gsywfzr;
    }

    public void setGsywfzr(String gsywfzr) {
        this.gsywfzr = gsywfzr;
    }

    public String getFycdbmfzr() {
        return fycdbmfzr;
    }

    public void setFycdbmfzr(String fycdbmfzr) {
        this.fycdbmfzr = fycdbmfzr;
    }

    public String getFgld() {
        return fgld;
    }

    public void setFgld(String fgld) {
        this.fgld = fgld;
    }

    public String getCwfgld() {
        return cwfgld;
    }

    public void setCwfgld(String cwfgld) {
        this.cwfgld = cwfgld;
    }

    public String getZgszjl() {
        return zgszjl;
    }

    public void setZgszjl(String zgszjl) {
        this.zgszjl = zgszjl;
    }

    public String getZc() {
        return zc;
    }

    public void setZc(String zc) {
        this.zc = zc;
    }

    public String getZgsdsz() {
        return zgsdsz;
    }

    public void setZgsdsz(String zgsdsz) {
        this.zgsdsz = zgsdsz;
    }

    public String getKjcl() {
        return kjcl;
    }

    public void setKjcl(String kjcl) {
        this.kjcl = kjcl;
    }

    public String getFyg() {
        return fyg;
    }

    public void setFyg(String fyg) {
        this.fyg = fyg;
    }

    public String getSxyyg() {
        return sxyyg;
    }

    public void setSxyyg(String sxyyg) {
        this.sxyyg = sxyyg;
    }

    public String getSxzxg() {
        return sxzxg;
    }

    public void setSxzxg(String sxzxg) {
        this.sxzxg = sxzxg;
    }

    public String getCwzxcn() {
        return cwzxcn;
    }

    public void setCwzxcn(String cwzxcn) {
        this.cwzxcn = cwzxcn;
    }

    public String getNgr() {
        return ngr;
    }

    public void setNgr(String ngr) {
        this.ngr = ngr;
    }

    public String getHqbmflb() {
        return hqbmflb;
    }

    public void setHqbmflb(String hqbmflb) {
        this.hqbmflb = hqbmflb;
    }

    public String getHqbmfxglb() {
        return hqbmfxglb;
    }

    public void setHqbmfxglb(String hqbmfxglb) {
        this.hqbmfxglb = hqbmfxglb;
    }

    public String getZbzjglg() {
        return zbzjglg;
    }

    public void setZbzjglg(String zbzjglg) {
        this.zbzjglg = zbzjglg;
    }

    public String getZbzjyybfzr() {
        return zbzjyybfzr;
    }

    public void setZbzjyybfzr(String zbzjyybfzr) {
        this.zbzjyybfzr = zbzjyybfzr;
    }

    public String getJtld() {
        return jtld;
    }

    public void setJtld(String jtld) {
        this.jtld = jtld;
    }

    public String getSxcwg() {
        return sxcwg;
    }

    public void setSxcwg(String sxcwg) {
        this.sxcwg = sxcwg;
    }

    public String getSxfxg() {
        return sxfxg;
    }

    public void setSxfxg(String sxfxg) {
        this.sxfxg = sxfxg;
    }

    public String getYsgly() {
        return ysgly;
    }

    public void setYsgly(String ysgly) {
        this.ysgly = ysgly;
    }

    public String getCwglbfzr() {
        return cwglbfzr;
    }

    public void setCwglbfzr(String cwglbfzr) {
        this.cwglbfzr = cwglbfzr;
    }

    public String getGhzx() {
        return ghzx;
    }

    public void setGhzx(String ghzx) {
        this.ghzx = ghzx;
    }

    public String getZjzjl() {
        return zjzjl;
    }

    public void setZjzjl(String zjzjl) {
        this.zjzjl = zjzjl;
    }
}
