package com.engine.htsc.tripInfo.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.tripInfo.cmd.TripInfoCmd;
import com.engine.htsc.tripInfo.service.TripInfoService;

import java.util.Map;

/**
 * Author:DTY-PC
 * Date:2020/10/29 11:07
 * Description: 联合差旅报销带出出差流程的行程信息和差旅费用信息
 * Copyright:上海泛微网络科技股份有限公司
 */
public class TripInfoServiceImpl extends Service implements TripInfoService {
    @Override
    public Map<String, Object> getTripInfo(Map<String, Object> params) {
        return commandExecutor.execute(new TripInfoCmd(user,params));
    }

}
