package com.engine.htsc.workflow.service.impl;

import com.engine.core.impl.Service;
import com.engine.htsc.workflow.cmd.DesignatedProcessorSettingsCmd;
import com.engine.htsc.workflow.cmd.DesignatedProcessorTableCmd;
import com.engine.htsc.workflow.cmd.DesignatedProcessorTableConditionCmd;
import com.engine.htsc.workflow.service.DesignatedProcessorSettingsService;

import java.util.Map;

public class DesignatedProcessorSettingsServiceImpl extends Service implements DesignatedProcessorSettingsService {

    @Override
    public Map<String, Object> getDesignatedProcessor(Map<String, Object> params) {
        return commandExecutor.execute(new DesignatedProcessorSettingsCmd(params));
    }

    @Override
    public Map<String, Object> getTable(Map<String, Object> params) {
        return commandExecutor.execute(new DesignatedProcessorTableCmd(params, user));
    }

    @Override
    public Map<String, Object> getTableConditions(Map<String, Object> params) {
        return commandExecutor.execute(new DesignatedProcessorTableConditionCmd(params, user));
    }
}
